<?php


/*
 *  Sivac - Sistema Online de Vacinao     
 *  Copyright (C) 2012  IPPES  - Institituto de Pesquisa, Planejamento e Promoo da Educao e Sade   
 *  www.sivac.com.br                     
 *  ippesaude@uol.com.br                   
 *                                                                    
 *  Este programa e software livre; voc pode redistribui-lo e/ou     
 *  modific-lo sob os termos da Licena Publica Geral GNU, conforme  
 *  publicada pela Free Software Foundation; tanto a verso 2 da      
 *  Licena como (a seu critrio) qualquer verso mais nova.          
 *                                                                    
 *  Este programa  distribudo na expectativa de ser til, mas SEM   
 *  QUALQUER GARANTIA; sem mesmo a garantia implcita de              
 *  COMERCIALIZACAO ou de ADEQUACAO A QUALQUER PROPOSITO EM           
 *  PARTICULAR. Consulte a Licena Publica Geral GNU para obter mais  
 *  detalhes.                                                         
 *                                                                    
 *  Voc deve ter recebido uma copia da Licena Publica Geral GNU     
 *  junto com este programa; se no, escreva para a Free Software     
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA          
 *  02111-1307, USA.                                                  
 *  
 *  Copia da licena no diretrio Sistema/licenca_en.txt 
 *                                Sistema/licenca_pt.txt 
 */


Sessao::Singleton()->ChecarAcesso();

$unidade = new UnidadeDeSaude();

$unidade->UsarBaseDeDados();

$unidade->ExibirOpcaoOperacaoDeEstoque(3);

$transporte = new Transporte();

$transporte->UsarBaseDeDados();

$data = new Data();

$unidade->ExibirFormularioRetornarEstoqueParaUnidadeCentral();

if(count($_POST)) {
	
	// Quando o admin for nivel 1000 ele pode escolher a unidade
	$unidade_id = $_SESSION['unidadeDeSaude_id'];
	if($_SESSION['nivel'] == 1000) $unidade_id = $_POST['unidade'];
		
	$vacina_id = $_POST['vacina'];
	$quantidade = $_POST['quantidade'];
	$unidadeDeSaudeOrigem_id  = $_POST['unidadeCentral'];
	$unidadeDeSaudeDestino_id = $_POST['unidade'];
	$lote = $_POST['lote'];
	$obs = $_POST['obs'];
	$validadeDoLote = $data->InverterData($_POST['validade']);
	$dataDeTransporte = $data->InverterData($_POST['datadeenvio']);

    $codigoDeBarras = $_POST['codigoDeBarras'];
	$produto = $_POST['produto'];

	
	
   // Verifica se os dados esto setados... 
	if( isset($_POST['vacina'], $_POST['quantidade']) && empty($_POST['estornar'])) {
		
		if ($unidade->VerificarEstoque($quantidade, $vacina_id, $unidadeDeSaudeDestino_id)) {
		
			//... e se conseguiu inserir um transporte e salvar o estoque
			$idIncluido = $transporte->InserirTransporte($unidadeDeSaudeOrigem_id, $unidadeDeSaudeDestino_id, 
			                                   $vacina_id, $quantidade, $dataDeTransporte, $lote, 
			                                   $validadeDoLote, $obs, $codigoDeBarras, $produto);
			                                   
			if ($idIncluido && $unidade->SalvarEstoque($unidadeDeSaudeOrigem_id, $vacina_id, $quantidade)
			    
			    //usando o prprio estornar para retirar da unidade central
				&& $unidade->EstornarEstoque($unidadeDeSaudeDestino_id, $vacina_id, $quantidade)) {
				
				//buscar o nome da Unidade de Sade
				$nome_unidade = $unidade->RetornarNomeUnidade($unidadeDeSaudeOrigem_id);	

                                // Captura o que o mtodo exibe para a varivel $botaoEstorno:
                                ob_start();
                                $unidade->ExibirBotaoEstornarEstoque($idIncluido);
                                $botaoEstorno = ob_get_contents();
                                ob_clean();

                                $botaoConfirmar = "<button name='estornar' type='submit' value='estornar'
                                                          style='color: #14E; width: 130px; margin:10px'
                                                          onclick=\"document.getElementById('containerDeMensagem').style.visibility = 'hidden';\">
                                                          <img src='{$unidade->LocalizarArquivoGeradorDeIcone()}?imagem=ok' alt='Sim'
                                                           style='vertical-align: middle' />Sim</button>";


                    // exibe msg de confirmao
                    $nomeVacina = $unidade->RetornarNome($vacina_id, 'vacina');
                    $unidade->ExibirMensagem("Sero retornadas $quantidade dose(s) da vacina $nomeVacina
					para a unidade de sade ". Html::FormatarMaiusculasMinusculas($nome_unidade) .
					". Deseja mesmo efetuar essa operao? <br /> $botaoConfirmar  $botaoEstorno", 'Ateno',
                                        'onclick');
			}
		}
		
		else {
			
			$unidade->ExibirMensagem('Quantidade para envio maior que o estoque atual!');
		}
	}
	
	
	// Se clicou no boto estornar:
	elseif( isset($_POST['estornar']) ) {

                // Verifica se o estoque recm acrescentado j no foi usado para vacinar.
                // S estorna quando o estoque recm inserido no foi usado:
		if ($unidade->VerificarEstoque($quantidade, $vacina_id, $unidadeDeSaudeOrigem_id)) {


                    if($transporte->ExcluirTransporte($idIncluidoExtornar)

                       //ao contrria do inserir transporte.ser devolvido os valores iniciais.
                       && $unidade->SalvarEstoque($unidadeDeSaudeDestino_id, $vacina_id, $quantidade)

                       && $unidade->EstornarEstoque($unidadeDeSaudeOrigem_id, $vacina_id, $quantidade)) {

                            $msg_estorno = "Foram removidas $quantidade doses desta "
                                                     . "unidade de sade.";

                            $_POST = array();

                            // Recarrega a pgina para que evite o F5 do usurio (que poderia
                            // "re-estornar" o estoque, gerando um nmero inteiro extremamente
                            // grande no banco de dados:
                            echo "<script>
                                            alert('$msg_estorno');
                                            window.location = '{$_SERVER['REQUEST_URI']}';
                                      </script>";
                   }
                    else {

                         $unidade->ExibirMensagem('Estoque no pode ser estornado!');
                    }
                }
		else {

                    $unidade->ExibirMensagem('Estoque j foi usado para vacinao e no poder ser estornado!');
		}
	}
	else {

		$unidade->ExibirMensagem('Estoque no foi atualizado.');
	}
}

$unidade->ExibirMensagensDeErro();
$transporte->ExibirMensagensDeErro();