<?php


/*
 *  Sivac - Sistema Online de Vacinao     
 *  Copyright (C) 2012  IPPES  - Institituto de Pesquisa, Planejamento e Promoo da Educao e Sade   
 *  www.sivac.com.br                     
 *  ippesaude@uol.com.br                   
 *                                                                    
 *  Este programa e software livre; voc pode redistribui-lo e/ou     
 *  modific-lo sob os termos da Licena Publica Geral GNU, conforme  
 *  publicada pela Free Software Foundation; tanto a verso 2 da      
 *  Licena como (a seu critrio) qualquer verso mais nova.          
 *                                                                    
 *  Este programa  distribudo na expectativa de ser til, mas SEM   
 *  QUALQUER GARANTIA; sem mesmo a garantia implcita de              
 *  COMERCIALIZACAO ou de ADEQUACAO A QUALQUER PROPOSITO EM           
 *  PARTICULAR. Consulte a Licena Publica Geral GNU para obter mais  
 *  detalhes.                                                         
 *                                                                    
 *  Voc deve ter recebido uma copia da Licena Publica Geral GNU     
 *  junto com este programa; se no, escreva para a Free Software     
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA          
 *  02111-1307, USA.                                                  
 *  
 *  Copia da licena no diretrio Sistema/licenca_en.txt 
 *                                Sistema/licenca_pt.txt 
 */


class RelatorioEstoqueDaUnidade extends Relatorio
{
//------------------------------------------------------------------------------

    /**
     * Construtor
     */
    public function __construct()
    {
        parent::__construct();

        Depurador::Pre('Classe instanaciada: ' . __CLASS__);
    }

//------------------------------------------------------------------------------

    public function ExibirRelatorio()
    {
        $crip = new Criptografia();
        parse_str($crip->Decifrar($_SERVER['QUERY_STRING']));
        
        $this->ImprimirCabecalho(Array('unidade_id'=>$unidade_id,'titulo'=>'Estoque de vacinas das unidades deste municpio'));
        $this->ExibirEstoqueDaUnidade($unidade_id);
    }
 //-----------------------------------------------------------------------------
    public function ExibirEstoqueDaUnidade($unidade_id)
	{
				$unidade_nome = false;
		$cidade_nome = Html::FormatarMaiusculasMinusculas($_SESSION['cidade_nome']);

		$sql = $this->conexao->prepare('SELECT vacina.nome,
			vacinadaunidade.quantidade
			FROM `vacina`, `vacinadaunidade`
			WHERE vacina.id = vacinadaunidade.Vacina_id
			AND UnidadeDeSaude_id = ?
			AND vacina.ativo  AND pertence = 0
			ORDER BY vacina.nome')
			or die(Bd::TratarErroSql($this->conexao->error, __FILE__, __LINE__));

		$sql->bind_param('i', $unidade_id);
	  	$sql->bind_result($nome, $quantidade);

	  	$sql->execute();
	  	$sql->store_result();
	  	$existemVacinas = $sql->num_rows;

	  	if($existemVacinas > 0) {

	  		$arr = array();
	  		$i = 0;
			  	while ($sql->fetch()) {

			  		$arr[$i] = array('Unidade de saude' => $unidade_nome,
							 'Vacina' => $nome,
			  				'Quantidade em estoque' => $quantidade);


			  		// Admin nivel 1 no pode ver outras uniades de saude
			  		if ($unidade_nome == false) unset($arr[$i]['Unidade de saude']);

			  		$i++;

			  	}

		  	Html::CriarTabelaDeArray($arr);
		  	return true;
	  	}

	  	if($existemVacinas == 0) {

			$this->ExibirMensagem('No existem vacinas estocadas nesta unidade.
	  			Atualize o estoque.');
	  	}

	  	if($existemVacinas < 0) {

			$this->AdicionarMensagemDeErro('Algum erro ocorreu ao exibir o
				estoque de vacinas desta unidade.');
	  	}
	}
}